#ifndef UNIQUE_HPP
#define UNIQUE_HPP

#include "x_types.h"

#define SETUP
#define N_GAMES			2
#define	COMPRESS
#define COMPRESS_RANGE
#define COMPRESS_RANGE_BITS     8
#define COMPRESS_RANGE_LEN      (1 << COMPRESS_RANGE_BITS)
#define MODE_LEN                COMPRESS_RANGE_LEN
#define MODE_LEN2               0
#define COMPRESSABLE(l)         ((l) <= MODE_LEN)
#define MAX_MODE_LEN            MODE_LEN
#define MAX_NETNODES            8
#define MAX_PACKET              256
#define CMD_SEND                1
#define CMD_GET                 2
#define CMD_BROADCAST           4

struct GameCom {
  short intnum;        // Game executes an int to send commands

// communication between Game and the driver

  short command;       // CMD_SEND or CMD_GET
  short remotenode;    // dest for send, set by get (-1 = no packet)
  short datalength;    // bytes in data to be sent / bytes read

// info specific to this node

  short consoleplayer; // 1-numplayers = player number
  short numplayers;    // 1-MAXPLAYERS
  short gametype;      // 1 = SERIAL, 2 = MODEM, 3 = NETWORK

  short extra;         // extra short for 4-byte alignment

// packet data to be sent

  byte	data[MAX_PACKET];
};

struct Setup {
  int gameID;
  int drone;
  int nodesFound;
  int nodesWanted;
  int game;
};

extern const int		cMethod[MODE_LEN + MODE_LEN2];
extern const char		*gameName[N_GAMES];
extern Setup			setup;

#endif
